Bug 450834 (CVE-2008-2664) - CVE-2008-2664 ruby: Unsafe use of alloca in rb_str_format()
Summary: CVE-2008-2664 ruby: Unsafe use of alloca in rb_str_format()
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2008-2664
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 451926 451927 451928 451929 451930 451931 452293 452294 452295
Blocks:
TreeView+ depends on / blocked
 
Reported: 2008-06-11 09:38 UTC by Tomas Hoger
Modified: 2019-09-29 12:24 UTC (History)
3 users (show)

Fixed In Version: 1.8.6.230-1.fc9
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2008-07-26 06:02:50 UTC


Attachments (Terms of Use)
Drew Yao's proposed patch against ruby 1.8.5 (519 bytes, patch)
2008-06-11 09:42 UTC, Tomas Hoger
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2008:0561 normal SHIPPED_LIVE Moderate: ruby security update 2008-07-16 14:14:30 UTC
Red Hat Product Errata RHSA-2008:0562 normal SHIPPED_LIVE Moderate: ruby security update 2008-07-14 13:43:04 UTC

Description Tomas Hoger 2008-06-11 09:38:20 UTC
Drew Yao of the Apple Product Security team reported that the rb_str_format()
function uses alloca() memory allocation function in insecure way, causing
memory address returned by alloca() to be out of stack memory space.  This can
be used to crash and possibly execute arbitrary code with the privileges of Ruby
application which use untrusted input in string operations.

Acknowledgements:

Red Hat would like to thank Drew Yao of the Apple Product Security team for reporting this issue.

Comment 1 Tomas Hoger 2008-06-11 09:42:54 UTC
Created attachment 308913 [details]
Drew Yao's proposed patch against ruby 1.8.5

ruby 1.9 does not use alloca in rb_str_format() any more.

Comment 5 Tomas Hoger 2008-06-20 18:52:44 UTC
Public now, lifting embargo:
http://preview.ruby-lang.org/en/news/2008/06/20/arbitrary-code-execution-vulnerabilities

Upstream released fixed versions:
1.8.5-p231, 1.8.6-p230, 1.8.7-p22, 1.9.0-2

Patches applied upstream:
http://svn.ruby-lang.org/cgi-bin/viewvc.cgi?view=rev&revision=17460
http://svn.ruby-lang.org/cgi-bin/viewvc.cgi?view=rev&revision=17472


Comment 7 Fedora Update System 2008-06-24 03:21:26 UTC
ruby-1.8.6.230-1.fc8 has been submitted as an update for Fedora 8

Comment 8 Fedora Update System 2008-06-24 05:18:00 UTC
ruby-1.8.6.230-1.fc9 has been submitted as an update for Fedora 9

Comment 9 Fedora Update System 2008-06-25 02:50:43 UTC
ruby-1.8.6.230-1.fc8 has been pushed to the Fedora 8 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 10 Fedora Update System 2008-06-25 02:52:18 UTC
ruby-1.8.6.230-1.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.